

/*
 *  Licensed Materials - Property of IBM
 *  Restricted Material of IBM
 *  IBM Rational Test RealTime
 *  (c) Copyright IBM Corp. 2003-2011 All Rights Reserved.
 *
 *  US Governement Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */


/*******************************************************************************
* $Descr: C/C++ Language Library Header $
*******************************************************************************/

/* Multiple inclusions guard: */
#ifndef TP_H_INCLUDED
#define TP_H_INCLUDED
#define RTRT_TDP_VERSION 8010 /* 8.0.1.0 */

/* Avoid compilation warnings if undefined */
#ifndef USE_ATU
#define USE_ATU 0
#endif
#ifndef USE_ATV
#define USE_ATV 0
#endif
#ifndef USE_ATS
#define USE_ATS 0
#endif
#ifndef USE_ATO
#define USE_ATO 0
#endif
#ifndef USE_ATP
#define USE_ATP 0
#endif
#ifndef USE_ATQ
#define USE_ATQ 0
#endif
#ifndef USE_ATC
#define USE_ATC 0
#endif
#ifndef USE_ATT
#define USE_ATT 0
#endif
#ifndef USE_ATK
#define USE_ATK 0
#endif

/* This is not the Target Package compilation */
/* RTRT_TDP_COMPILATION is not defined : */
/* #define RTRT_TDP_COMPILATION */

#if USE_ATS || USE_ATK
/* Compilation options (from Studio settings) */
#include "options.h"
#endif

/* Values used by customization file */
#include "rtvalues.h"

/* What the Target Package implements */
#include "custom.h"

/* Defaults settings */
#include "atldefaults.h"

/* Init/exit header */
#include "initexit.h"

/* Clock management header */
#include "atlclock.h"

/* I/O and system routines header */
#include "priv.h"

/* Threads synchronization/protection objects management */
#include "tasking.h"

/* Presentation functions header */
#include "atlimage.h"

#if USE_ATT || USE_ATP || USE_ATQ
/* Call stack */
#include "rtstack.h"
#endif

#if (USE_ATO || USE_ATK) && defined(ATL_CPLUSPLUS_INSTRUMENTOR)
/* Routines instrumentation macros */
#include "routinst.h"
#endif

#if USE_ATO
/* TestRT Object Testing specifics */
#include "ato.h"
#elif USE_ATV
/* TestRT Visual Testing specifics */
#include "atv.h"
#elif USE_ATS
/* TestRT System Testing specifics */
#include "ats.h"
#elif USE_ATU
/* TestRT Unit Testing specifics */
#include "atu.h"
#endif

#if USE_ATP || USE_ATQ || USE_ATC || USE_ATT
/* Observation Tools common functions */
#include "obstools.h"
#endif

#if USE_ATK
/* TestRT Contract Check specifics */
#include "atk.h"
#endif

#if USE_ATC
/* TestRT Coverage specifics */
#include "atc.h"
#endif

#if USE_ATT
/* TestRT Trace specifics */
#include "att.h"
#endif

#if USE_ATP
/* TestRT PurifyLT specifics */
#include "atp.h"
#endif

#if USE_ATQ
/* TestRT QuantifyLT specifics */
#include "atq.h"
#endif

#endif
